macroScript BaseJump category:"Bobo_s Tools"
(

---------------------------------------------------------------------
--BaseJump
--Version 2.1
--Started: 04/20/2003
--Edited : 12/03/2004
--Code by Borislav Petrov
--bobo@franticfilms.com
---------------------------------------------------------------------	

	global BaseJump_Rollout
	persistent global BaseJump_Last_Settings 
	global BaseJumpCallbackFunction

	fn BaseJumpCallbackFunction =
	(
		BaseJump_Rollout.jump_local_result.color = blue
		BaseJump_Rollout.jump_class_result.color = blue
		BaseJump_Rollout.jump_level_result.color = blue
		BaseJump_Rollout.jump_base_result.color = blue
		if BaseJump_Rollout.enable_callback.checked and selection.count == 1 then
		(
			theObj = selection[1]
--			for i in (refs.dependents (modPanel.getCurrentObject())) where (classof (superclassof i)) == node collect i
			if BaseJump_Rollout.jump_local.checked then
			(
				for m in theObj.modifiers do
				(
					if (theData = getAppData m 20041202) != "" then 
					(
						modPanel.setCurrentObject m node:theObj
						if BaseJump_Rollout.jump_local_subobject.checked then
						(
							try
							(
								subObjectLevel = execute theData
								BaseJump_Rollout.jump_local_result.color = green
							)
							catch
								BaseJump_Rollout.jump_local_result.color = orange
						)	
						else
							BaseJump_Rollout.jump_local_result.color = green
						return true
					)--end if
				)--end m loop
				if getAppData theObj.baseobject 20041202 != "" then
				(
						modPanel.setCurrentObject theObj.baseobject
						if BaseJump_Rollout.jump_local_subobject.checked then
						(
							try
							(
								subObjectLevel = execute theData
								BaseJump_Rollout.jump_local_result.color = green
							)
							catch
								BaseJump_Rollout.jump_local_result.color = orange
						)		
						else
							BaseJump_Rollout.jump_local_result.color = green
						return true
				)
				BaseJump_Rollout.jump_local_result.color = red
			)
			else
				BaseJump_Rollout.jump_local_result.color = yellow
				
			if BaseJump_Rollout.jump_class.checked then
			(
				theModifiers = for i = 1 to theObj.modifiers.count where (classof theObj.modifiers[i]) as string == BaseJump_Rollout.jump_modifier.selected collect i
				if theModifiers.count > 0 then
				(
					modNumberToJump = BaseJump_Rollout.mod_number.value 
					if modNumberToJump  > theModifiers.count then
					(
						modNumberToJump = theModifiers.count
						resultColor = orange
					)	
					else 
						resultColor = green
					try
					(
						modPanel.setCurrentObject (theObj.modifiers[theModifiers[modNumberToJump]])
						BaseJump_Rollout.jump_class_result.color = resultColor 
						return true
					)catch()
				)
				BaseJump_Rollout.jump_class_result.color = red
			)	
			else
				BaseJump_Rollout.jump_class_result.color = yellow
				
			if BaseJump_Rollout.jump_level.checked then
			(
				try
				(
					modPanel.setCurrentObject (theObj.modifiers[theObj.modifiers.count+1-BaseJump_Rollout.mod_level.value])
					BaseJump_Rollout.jump_level_result.color = green
					return true
				)catch()
				BaseJump_Rollout.jump_level_result.color = red
			)
			else
				BaseJump_Rollout.jump_level_result.color = yellow
				
			if BaseJump_Rollout.jump_base.checked then
			(
				try
				(
					modPanel.setCurrentObject (selection[1].baseobject)
					BaseJump_Rollout.jump_base_result.color = green	
					return true
				)catch()
				BaseJump_Rollout.jump_base_result.color = red
			)
			else
				BaseJump_Rollout.jump_base_result.color = yellow
		)		
	)	
	rollout BaseJump_Rollout "Modifier BaseJump 2.1" 
	(
		checkbutton jump_local "Local" width:74 across:4 align:#left offset:[-10,0] tooltip:"Enable Jump to predefined Local Target on the Modifier Stack."
		checkbutton jump_local_subobject "SubO" width:40 align:#center offset:[13,0] tooltip:"Enable Jump to predefined Sub-Object Level of the Local Target." 
		button set_local "Set Current..." width:80 align:#center offset:[25,0] tooltip:"Set the Current Modifier Stack Object as a Local Target for the selected node."
		progressbar jump_local_result width:12 height:22 align:#right offset:[10,0] value:100 color:blue
		
		checkbutton jump_class "Modifier Class" width:74 across:3 align:#left offset:[-10,0] tooltip:"Enable Jump to the specified Modifier Class. Use Pref.Modifier to specify which Modifier to jump to, if more than one of the kind."
		dropdownlist jump_modifier items:#() align:#center width:120 offset:[30,0]
		progressbar jump_class_result width:12 height:22 align:#right offset:[10,0] value:100 color:blue
		
		checkbutton jump_level "Level" width:74 across:3 align:#left offset:[-10,0] tooltip:"Enable Jump to specified Level on the Modifier Stack, counting from Base Object up."
		spinner mod_level "Pref. Level:" range:[1,100,1] type:#integer fieldwidth:30 align:#center offset:[40,3]
		progressbar jump_level_result width:12 height:22 align:#right offset:[10,0] value:100 color:blue
		
		checkbutton jump_base "BaseObject" width:74 align:#left offset:[-10,0] across:3 tooltip:"Enable Jump to Base Object if all above tests are OFF or Failed to locate a jump target."
		spinner mod_number "Pref. Modifier:" range:[1,100,1] type:#integer fieldwidth:30 align:#center offset:[34,3]
		progressbar jump_base_result width:12 height:22 align:#right offset:[10,0] value:100 color:blue
		
		checkbutton enable_callback "ENABLE BASE JUMP" width:214 height:30 --highlightcolor:(color 200 255 200)
		
		fn updateCallback = 
		(
			callbacks.removeScripts id:#bobo_modstacklevel
			if enable_callback.state then 
				callbacks.addScript #modPanelSelChanged "BaseJumpCallbackFunction()" id:#bobo_modstacklevel
			BaseJump_Last_Settings = #(true, jump_class.state, jump_modifier.selection, jump_level.state, mod_level.value, jump_base.state, mod_number.value, jump_local.state, jump_local_subobject.state )
		)
		
		fn disableCallback =
		(
			callbacks.removeScripts id:#bobo_modstacklevel
--			BaseJump_Last_Settings[1] = false
		)		
		
		on enable_callback changed state do
		(
			if state then
				updateCallback()
			else
				disableCallback()
		)	
		
		on set_local pressed do
		(
			if selection.count == 1 then
			(
				try
				(
					for m in selection[1].modifiers do 
						setAppData m 20041202 ""
					setAppData (selection[1].baseobject) 20041202 ""
					setAppData (modPanel.getCurrentObject()) 20041202 (subObjectLevel as string)
					pushprompt ("BaseJump: Local Jump set to "+(modPanel.getCurrentObject()) as string)
				)catch(pushprompt "BaseJump: Failed to set Local Jump!")	
			)
			else
				pushprompt "BaseJump: Please select only one object!"
		)
		
		on BaseJump_Rollout close do disableCallback()
		on mod_level changed val do updateCallback()
		on mod_number changed val do updateCallback()
		
		on jump_modifier selected itm do updateCallback()			
		on jump_class changed state do updateCallback()			
		on jump_level changed state do updateCallback()			
		on jump_base changed state do updateCallback()			
		on jump_local changed state do updateCallback()		
		on jump_local_subobject changed state do updateCallback()		
		
		on 	BaseJump_Rollout moved pos do
			setIniSetting (GetDir #plugcfg + "/BaseJump.ini") "Settings" "Position" (pos as string)
	)
	
	try(destroyDialog BaseJump_Rollout)catch()
	pos = getIniSetting (GetDir #plugcfg + "/BaseJump.ini") "Settings" "Position" 
	if pos == "" then pos = [100,100] else pos = execute pos
	createDialog BaseJump_Rollout 220 145 pos.x pos.y
	mod_names = for i in modifier.classes collect (i as string)
	mod_names = sort mod_names 
	BaseJump_Rollout.jump_modifier.items = mod_names
	
	if 	BaseJump_Last_Settings != undefined then
	(
		try
		(
			BaseJump_Rollout.enable_callback.checked = BaseJump_Last_Settings[1]
			BaseJump_Rollout.jump_class.state = BaseJump_Last_Settings[2]
			BaseJump_Rollout.jump_modifier.selection = BaseJump_Last_Settings[3]
			BaseJump_Rollout.jump_level.state = BaseJump_Last_Settings[4]
			BaseJump_Rollout.mod_level.value = BaseJump_Last_Settings[5]
			BaseJump_Rollout.jump_base.state = BaseJump_Last_Settings[6]
			BaseJump_Rollout.mod_number.value = BaseJump_Last_Settings[7]
			BaseJump_Rollout.jump_local.state = BaseJump_Last_Settings[8]
			BaseJump_Rollout.jump_local_subobject.state = BaseJump_Last_Settings[9]
		)catch()	
		BaseJump_Rollout.updateCallback()
	)
)
